package net.ericaro.neobin;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.logging.Logger;

import org.stringtemplate.v4.ST;
import org.stringtemplate.v4.STGroupFile;

public class CBinGenerator {

	static Logger LOG = Logger.getLogger("net.ericaro.neobin");
	private final File	targetDirectory;
	private final BinaryFormat	format;
	
	
	public CBinGenerator(BinaryFormat format, File targetDirectory) {
		this.format = format;
		this.targetDirectory = targetDirectory;
		
	}
	
	
	
	public static void compile(BinaryFormat format, File targetDirectory) throws IOException {
		new CBinGenerator(format, targetDirectory).compile() ;
	}

	public void compile() throws IOException {
		// todo create stg for c purpose and generate the sources
//		g("FileChannelReader"   , "c");
//		g("FileChannelReceiver" , "c");
//		g("FileChannelWriter"   , "c");
//		g("MapAddr"             , "c");
//		g("BinaryReceiver"      , "c");
//		g("BinaryReader"        , "c");
//		g("BinaryWriter"        , "c");
	
	}
	
	/**
	 * 
	 * @param name template name
	 * @param type generated file type ( usually either "h" or "c")
	 * @throws IOException
	 */
	private void g(String name, String type) throws IOException {
		LOG.info("    generating "+name);
		ST unit = new STGroupFile("net/ericaro/neobin/"+name+".stg").getInstanceOf("FileUnit");
		assert unit != null :"unexpected null ST unit";
		unit.add("format", format);
		String content = unit.render();
		toDir(targetDirectory, name+"."+type, content); 
	}
	
	public static void toDir(File dir, String filename, String content) throws IOException {
		File file = new File(dir, filename );
		file.getParentFile().mkdirs();
		OutputStreamWriter w = new OutputStreamWriter(
				new FileOutputStream(file));
		w.write(content);
		if (true)
			w.close();
		LOG.info("    generated "+file.getPath());
	}
	
	
}
